;	int2f.asm
;	Copyright (c) 1991 Code Craft Software
;	For use with dBase III Plus version 1.1
;	dbase.ovl dated 07-24-86 12:00 PM  This may not work properly with
;	other versions or releases of dBase III Plus.
;
;	To use:
;	LOAD int2f
;	STORE "H" TO mode
;	CALL int2f WITH mode		&&	request hook
;	if mode <> "H"
;		? "Error hooking interrupt 2Fh"
;	endif
;	*	rest of program
;	STORE "U" TO mode			&&	request unhhok
;	if mode <> "U"
;		? "Error unhooking interrupt 2Fh"
;	endif
;	RELEASE MODULE int2f
;
;	Error codes are punched into the parameter.  Note the following
;	return codes:	E - parameter error
;				A - already hooked (when trying to hook)
;				N - not hooked (when trying to unhook)
;	If the call was successful, the calling code will remain as original.
;
;	To compile:	tasm int2f
;	   To link:	tlink /t int2f, int2f.bin
;
ASSUME	CS:CODE_SEG

CODE_SEG	SEGMENT
	ORG 0

INT2F PROC FAR
	jmp short chkparams

sv2f	dw	0,0					;	saved int 2f segment
zero dw	0
chkparams:
	or	bx, bx				;	was parameter passed
	jz	badparams
	mov	al, ds:[bx]			;	move parameter to al
	cmp	al, 'H'
	je	askhook
	cmp	al, 'U'
	je	askunhook
badparams:
	mov	ds:byte ptr [bx], 'E'
	retf
askhook:
	mov	ax, cs:[sv2f]
	or	ax, cs:[sv2f+2]
	jz	dohook
	mov	ds:byte ptr [bx], 'A'
	retf
dohook:
	pushf
	push	ds
	mov	ds, cs:[zero]			;	kill the ds register
	cli						;	turn interrupts off
	mov	ax, OFFSET isr2f
	xchg	ax, ds:[0bch]			;	offset of vector 2F
	mov	cs:[sv2f], ax			;	store offset
	mov	ax, cs
	xchg	ax, ds:[0beh]			;	segment of vector 2F
	mov	cs:[sv2f+2], ax		;	store offset at cs:4
	pop	ds
	popf						;	turn interrupts on again
	retf
askunhook:
	mov	ax, cs:[sv2f]
	or	ax, cs:[sv2f+2]
	jne	dounhook
	mov	ds:byte ptr [bx], 'N'
	retf

dounhook:
	push ds
	pushf
	mov	ds, cs:[zero]			;	kill the ds register
	cli						;	turn interrupts off
	xor	ax, ax
	xchg	ax, cs:[sv2f]			;	store offset
	mov	ds:[0bch], ax			;	offset of vector 2F
	xor	ax, ax
	xchg	ax, cs:[sv2f+2]		;	store offset
	mov	ds:[0beh], ax			;	offset of vector 2F
	popf						;	turn interrupts on again
	pop	ds
	retf

isr2f:
	cmp	ah,0CFh				;	check for our id
	jne	notus

	or	al,al				;	check for id request
	jne	not0
	mov	al,0FFh				;	say we're here
done:
	iret
not0:
	push	ds
	mov	ds, [bp+6]			;	get dbase's ds
	cmp	ds:[7ca2h], 0			;	majic location for keys in buffer
	pop	ds
	je	empty
	mov	al, 1				;	indicate not empty
	jmp	short done
empty:
	mov	al, 0				; 	indicate empty
	jmp	short done

not1:
	mov	al,0EEh				;	indicate unknown request
	jmp	short done

notus:
	jmp	cs:dword ptr [sv2f]		;	call down the pipe

INT2F ENDP

CODE_SEG	ENDS
	END
